﻿#include <iostream>
#include <winsock.h>
#pragma comment( lib, "ws2_32.lib" )
using namespace std;

void main(void) {
    WSAData wsaData;
    SOCKET sockReceiver = NULL;
    SOCKADDR_IN addrReceiver;
    try {

        if (WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) {
            throw WSAGetLastError();
        }

        sockReceiver = socket(AF_INET, SOCK_DGRAM, 0);
        if (sockReceiver == INVALID_SOCKET) {
            throw WSAGetLastError();
        }

        BOOL bEnable = TRUE;
        if (setsockopt(sockReceiver, SOL_SOCKET, SO_BROADCAST, (char*)&bEnable, sizeof(bEnable)) == SOCKET_ERROR) {
            throw WSAGetLastError();
        }
        memset((void*)&addrReceiver, 0, sizeof(SOCKADDR));
        addrReceiver.sin_family = AF_INET;
        //addrReceiver.sin_port = htons(9000);
        addrReceiver.sin_port = htons(9901);
        addrReceiver.sin_addr.s_addr = htonl(INADDR_ANY);

        if (bind(sockReceiver, (SOCKADDR*)&addrReceiver, sizeof(SOCKADDR)) == SOCKET_ERROR) {
            throw WSAGetLastError();
        }

        SOCKADDR_IN senderAddr;
        int addrLen = sizeof(SOCKADDR_IN);
        char buf[1024] = { 0, };
        while (1) {
            if (recvfrom(sockReceiver, buf, strlen(buf), 0, (SOCKADDR*)&senderAddr, &addrLen) == SOCKET_ERROR) {
                throw WSAGetLastError();
            }
            cout << buf << endl; memset(buf, 0, 1024);
        }
    }
    catch (int& ex) {
        cout << "Error Code: " << ex << endl;
    }
    closesocket(sockReceiver);
    WSACleanup();
}